Attribute VB_Name = "modUtilita"
'=======================================================================================
' Descrizione.....: Routines di utilita' per SigGen.  Non tutte le routines
'                   di questo modulo vengono, necessariamente, usate.
' Nome dei Files..: modUtilita.bas
' Data............: 13/06/1999
' Aggiornamento...: 31/03/2001
' Aggiornamento...: 03/08/2005
' Aggiornamento...: 03/02/2007
' Versione........: 1.2 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
Public Const PI# = 3.14159265358979     ' 4# * Atn(1#)
Public Const PI2# = 2# * PI
Public Const PI_2# = PI / 2#
Public Const e# = 2.71828182845905      ' Exp(1#)
Public Const Log2# = 0.693147180559945  ' Log(2#)
Public Const Log10# = 2.30258509299405  ' Log(10#)
Public Const Sqr2# = 1.4142135623731    ' Sqr(2#)
'
Public Const ColEvi& = vbInfoBackground ' Colore degli evidenziatori.
'
'--- GetIniString, SaveIniString: ------------------------------------------------------
Private Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, _
    ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, ByVal lpString As Any, _
    ByVal lpFileName As String) As Long
'
'--- SysSep: ---------------------------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
(ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String _
, ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDECIMAL& = &HE
'
'--- Remove Menu: ----------------------------------------------------------------------
Private Declare Function RemoveMenu Lib "USER32" (ByVal hMenu As Long _
, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function GetSystemMenu Lib "USER32" (ByVal hWnd As Long _
, ByVal bRevert As Long) As Long
Private Declare Function DrawMenuBar Lib "USER32" (ByVal hWnd As Long) As Long
'
Private Const MF_REMOVE& = &H1000&
Private Const MF_ENABLED& = &H0&
Private Const MF_INSERT& = &H0&
'
Private Const SC_CLOSE& = &HF060&
Private Const SC_MINIMIZE& = &HF020&
Private Const SC_MAXIMIZE& = &HF030&
Private Const SC_RESTORE& = &HF120&
'
'--- VerificaSchedaAudioOutCap: --------------------------------------------------------
Private Const MMSYSERR_NOERROR& = 0
Private Const WAVE_FORMAT_PCM& = 1
Private Const WAVE_FORMAT_QUERY& = &H1
Private Const WAVERR_BADFORMAT& = 32    ' unsupported wave format
'
Private Type WAVEFORMATEX
    wFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    wBitsPerSample As Integer
    cbSize As Integer
End Type
'
Private Declare Function waveOutOpen Lib "winmm.dll" _
    (lphWaveOut As Long, ByVal uDeviceID As Long, _
    ByVal WaveFormatExPointer As Long, ByVal dwCallback As Long, _
    ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
'
'--- DSHIFT: ---------------------------------------------------------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
'
'--- Ran0, Ran1, PinkNoise, WhiteGaussNoise e WhiteNoise: ------------------------------
Private Const IA& = 16807, Im& = 2147483647, AM! = 1! / Im, AM2! = 2! / Im
Private Const IQ& = 127773, IR& = 2836, MASK& = 123459876
Private Const NTAB& = 32, NDIV& = 1 + (Im - 1) / NTAB
Private Const EPS! = 0.00000012, RNMX! = 1! - EPS
Private Const PN0! = 0.099046 * AM2, PN1! = 0.2965164 * AM2
Private Const PN2! = 1.0526913 * AM2, PN3! = 0.1848 * AM2
Public Function Ran0(ByRef Idum As Long) As Single
'
'   Minimal random number generator of Park and Miller. Returns a uniform random
'   deviate between 0.0 and 1.0. Set or reset idum to any integer value (except
'   the unlikely value MASK) to initialize the sequence; idum must not be altered
'   between calls for successive deviates in a sequence.
'
'   Codice tradotto dal FORTRAN (pg. 270) di:
'    Numerical Recipes in FORTRAN 77
'    The Art of Scientific Computing
'    Second Edition Volume 1 of
'    FORTRAN Numerical Recipes
'    di William H. Press ed altri.
'
    Dim K As Long
'
    Idum = (Idum Xor MASK)  ' XORing with MASK allows use of zero
                            ' and other simple bit patterns for idum.
'
    K = Idum / IQ
    Idum = IA * (Idum - K * IQ) - IR * K    ' Compute idum=mod(IA*idum,IM) without
                                            ' overflows by Schrage 's method.
    If (Idum < 0) Then Idum = Idum + Im
'
    Ran0 = AM * Idum                        ' Convert idum to a floating result.
'
    Idum = (Idum Xor MASK)  ' Unmask before return.
'
'
'
End Function
Private Sub DFT(D() As Double, R() As Double, X() As Double, _
    ByVal NVAL As Long, ByRef NFre As Long)
'
'   Definizioni:
'
'   DFT = Discrete Fourier Transform.
'
'   Entra con:
'       D()    = Vettore dei dati Reali del Segnale(t).
'       NVAL   = Numero max. dei dati in D() da usare.
'
'   Esce  con:
'       R()    = Vettore dei valori Reali      della Trasformata(f).
'       X()    = Vettore dei valori Immaginari della Trasformata(f).
'       NFRE   = Numero  dei valori di Frequenza calcolati.
'
'   I valori della Trasformata in R(), X() vengono
'   normalizzati sulla lunghezza del Segnale NVAL.
'
'   I vettori R(), X() sono dimensionati in questa routine.
'   Gli NN dati nei vettori sono organizzati come Vettore(0 To NN - 1).
'
'   Viene calcolata in R(0 To NFRE), X(0 To NFRE) solo la prima
'   meta' dello spettro per i valori di frequenza  NFRE = NVAL/2
'   piu' la Componente Continua in R(0).
'
'   Algoritmi tratti da: "Digital Time Series Analysis" di R. Otnes
'   e L. Enochson - pg. 138.  Nessun tentativo e' stato fatto per
'   migliorare la velocita' di esecuzione (tipo look-up table e/o
'   valutazione ricorsiva delle funzioni trigonometriche).
'
'   Versione ridotta per SigGen.
'
    Dim JF&, JD&, PI2_V#, NVAL_2#, Omega#, OmT#
'
    NFre = Int(NVAL / 2)
    PI2_V = PI2 / CDbl(NVAL)
    NVAL_2 = CDbl(NVAL) / 2#
'
    ReDim R(0 To NFre), X(0 To NFre)
'
    For JF = 0 To NFre
        Omega = PI2_V * CDbl(JF)
        R(JF) = 0#
        X(JF) = 0#
'
        For JD = 0 To NVAL - 1
            OmT = Omega * CDbl(JD)
            R(JF) = R(JF) + D(JD) * Cos(OmT)
            X(JF) = X(JF) + D(JD) * Sin(OmT)
        Next JD
    Next JF
'
    ' Normalizzazione:
    R(0) = R(0) / CDbl(NVAL)
    For JF = 1 To NFre - 1
        R(JF) = R(JF) / NVAL_2
        X(JF) = X(JF) / NVAL_2
    Next JF
    If ((NVAL Mod 2) = 0) Then
        R(NFre) = R(NFre) / CDbl(NVAL)
        X(NFre) = X(NFre) / CDbl(NVAL)
    Else
        R(NFre) = R(NFre) / NVAL_2
        X(NFre) = X(NFre) / NVAL_2
    End If
'
'
'
End Sub
Private Function Ran1(ByRef Idum As Long) As Single
'
'   "Minimal" random number generator of Park and Miller with Bays-Durham shuffle and
'   added safeguards. Returns a uniform random deviate between 0.0 and 1.0 (exclusive
'   of the endpoint values). Call with idum a negative integer to initialize;
'   thereafter, do not alter idum between successive deviates in a sequence.
'   RNMX should approximate the largest floating value that is less than 1.
'
'   Codice tradotto dal FORTRAN (pg. 271) di:
'    Numerical Recipes in FORTRAN 77
'    The Art of Scientific Computing
'    Second Edition Volume 1 of
'    FORTRAN Numerical Recipes
'    di William H. Press ed altri.
'
    Dim J&, K&
    Static iv&(1 To NTAB), iy&
'
    If (Idum < 0) Or (iy = 0) Then      ' Initialize.
        Idum = MAX0(-Idum, 1)           ' Be sure to prevent idum = 0.
        For J = NTAB + 8 To 1 Step -1   ' Load the shuffle table (after 8 warm-ups).
            K = Idum / IQ
            Idum = IA * (Idum - K * IQ) - IR * K
            If (Idum < 0) Then Idum = Idum + Im
            If (J <= NTAB) Then iv(J) = Idum
        Next J
        iy = iv(1)
    End If
'
    K = Idum / IQ ' Start here when not initializing.
    Idum = IA * (Idum - K * IQ) - IR * K    ' Compute idum=mod(IA*idum,IM) without
                                            ' overflows by Schrage 's method.
    If (Idum < 0) Then Idum = Idum + Im
    J = 1 + Int(iy / NDIV)                  ' Will be in the range 1:NTAB.
    iy = iv(J)                              ' Output previously stored value and
                                            ' refill the shuffle table.
    iv(J) = Idum
    Ran1 = DMIN1(AM * iy, RNMX)             ' Because users don't expect endpoint values.
'
'
'
End Function
Public Function WhiteGaussNoise(ByRef Idum As Long) As Single
'
'   Returns a normally distributed deviate with zero mean and unit variance,
'   using ran0(Idum) as the source of uniform deviates.
'
'   Codice tradotto e modificato dal FORTRAN (pg. 280) di:
'    Numerical Recipes in FORTRAN 77
'    The Art of Scientific Computing
'    Second Edition Volume 1 of
'    FORTRAN Numerical Recipes
'    di William H. Press ed altri.
'
'   Versione modificata per SigGen.
'   Versione con sviluppo in linea di Ran0(Idum)
'   per velocizzare l' esecuzione della routine:
'
    Dim K&, fac!, rsq!, v1!, v2!
    Static gset!, bset As Boolean
'
    If (Idum < 0) Then bset = False ' Reinitialize.
'
    If bset Then                    ' We have an extra deviate handy,
        WhiteGaussNoise = gset      ' so return it,
        bset = False                ' and unset the flag.
'
    Else
        Idum = (Idum Xor MASK)      ' XORing with MASK allows use of zero
                                    ' and other simple bit patterns for idum.
'
        Do                                      ' We don't have an extra deviate handy, so
            'v1 = 2! * Ran0(Idum) - 1!           ' pick two uniform numbers in the square
            'v2 = 2! * Ran0(Idum) - 1!           ' extending from -1 to +1 in each direction.
'
            ' v1:
            K = Idum / IQ
            Idum = IA * (Idum - K * IQ) - IR * K    ' Compute idum=mod(IA*idum,IM) without
                                                    ' overflows by Schrage 's method.
            If (Idum < 0) Then Idum = Idum + Im
            v1 = AM2 * Idum - 1!                    ' Convert idum to a floating result;
                                                    ' -1.0 < v1 < +1.0.
'
            ' v2:
            K = Idum / IQ
            Idum = IA * (Idum - K * IQ) - IR * K
'
            If (Idum < 0) Then Idum = Idum + Im
            v2 = AM2 * Idum - 1!                    ' -1.0 < v2 < +1.0.
'
            rsq = v1 * v1 + v2 * v2             ' See if they are in the unit circle,
        Loop While ((1! <= rsq) Or (rsq = 0!))  ' and if they are not, try again.
'
        fac = Sqr(-2 * Log(rsq) / rsq)          ' Now make the Box-Muller transformation
        WhiteGaussNoise = v1 * fac              ' to get two normal deviates. Return one
        gset = v2 * fac                         ' and save the other for next time.
'
        bset = True             ' Set flag.
        Idum = (Idum Xor MASK)  ' Unmask before return.
    End If
'
'
'
End Function
Public Function GasDev(ByRef Idum&) As Single
'
'   Returns a normally distributed deviate with zero mean and unit variance,
'   using ran0(Idum) as the source of uniform deviates.
'
'   Codice tradotto dal FORTRAN (pg. 280) di:
'    Numerical Recipes in FORTRAN 77
'    The Art of Scientific Computing
'    Second Edition Volume 1 of
'    FORTRAN Numerical Recipes
'    di William H. Press ed altri.
'
    Dim fac!, rsq!, v1!, v2!
    Static iset&, gset!
'
    If (Idum < 0) Then iset = 0                 ' Reinitialize.
    If (iset = 0) Then
        Do                                      ' We don't have an extra deviate handy, so
            v1 = 2! * Ran0(Idum) - 1!           ' pick two uniform numbers in the square
            v2 = 2! * Ran0(Idum) - 1!           ' extending from -1 to +1 in each direction,
            rsq = v1 * v1 + v2 * v2             ' see if they are in the unit circle,
        Loop While ((1! <= rsq) Or (rsq = 0!))  ' and if they are not, try again.
'
        fac = Sqr(-2 * Log(rsq) / rsq)          ' Now make the Box-Muller transformation
        gset = v1 * fac                         ' to get two normal deviates. Return one
        GasDev = v2 * fac                       ' and save the other for next time.
'
        iset = 1        ' Set flag.
'
    Else                ' We have an extra deviate handy,
        GasDev = gset   ' so return it,
        iset = 0        ' and unset the flag.
    End If
'
'
'
End Function
Public Sub FormatPrf(ByVal vNum As Variant, ByRef Mantissa$, ByRef Prefisso$, _
    Optional ByVal strF$ = "0.000E+00")
'
'   Trasforma il valore vNum in formato SI con mantissa e prefisso,
'   i.e. micro (), milli (m), ..., kilo (k), etc... conservando il
'   numero di cifre della mantissa di strF$.
'   La mantissa di strF$ deve sempre avere almeno uno 0 prima e dopo
'   il punto decimale; strF$ deve essere in formato scientifico, i.e.
'   contenere i caratteri "E+0[0[0]]".
'
'   Nota: accertarsi che il Font usato per scrivere il Prefisso$
'         contenga il carattere "".
'
    Dim FTemp$, EPos&
'
    FTemp$ = FormatE$(vNum, strF$)
'
    EPos = InStr(FTemp$, "E")
'
    Mantissa$ = Left$(FTemp$, EPos - 1)
'
    Select Case Val(Mid$(FTemp$, EPos + 1))
    Case -18
        Prefisso$ = "a" ' (atto).
    Case -15
        Prefisso$ = "f" ' (femto).
    Case -12
        Prefisso$ = "p" ' (pico).
    Case -9
        Prefisso$ = "n" ' (nano).
    Case -6
        Prefisso$ = "" ' (micro).
    Case -3
        Prefisso$ = "m" ' (milli).
    Case 0
        Prefisso$ = ""
    Case 3
        Prefisso$ = "k" ' (kilo).
    Case 6
        Prefisso$ = "M" ' (mega).
    Case 9
        Prefisso$ = "G" ' (giga).
    Case 12
        Prefisso$ = "T" ' (tera).
    Case 15
        Prefisso$ = "P" ' (peta).
    Case 18
        Prefisso$ = "E" ' (eka).
'
    Case Else
        Prefisso$ = "?" ' non lo so' :-)).
    End Select
'
'
'
End Sub
Private Function LinInt(X() As Double, Y() As Double, ByVal Xn As Double) As Double
'
'   Given the arrays X(1:N) and Y(1:N) of length N, which tabulate a function
'   (with the xi 's in order), and given a value of Xn, this routine returns
'   a piece-wise linear interpolated value.
'
    Dim K&, khi&, klo&, h#
'
    ' We will find the right place in the table by means of bisection.
    ' This is optimal if sequential calls to this routine are at random
    ' values of x. If sequential calls are in order, and closely
    ' spaced, one would do better to store previous values of
    ' klo and khi and test if they remain appropriate on the next call.
'
    ' Codice tradotto e modificato dal FORTRAN (pg. 110) di:
    '  Numerical Recipes in FORTRAN 77
    '  The Art of Scientific Computing
    '  Second Edition Volume 1 of
    '  FORTRAN Numerical Recipes
    '  di William H. Press ed altri.
'
    klo = 1
    khi = UBound(X)
'
    Do While (1 < khi - klo)
        K = (khi + klo) / 2
        If (Xn < X(K)) Then
            khi = K
        Else
            klo = K
        End If
    Loop
    ' klo and khi now bracket the input value of xn.
'
    h = X(khi) - X(klo)
    'if (h = 0#) Then ...  routine di gestione errore.  ' bad xi input in LinInt
                                                        ' The xi 's must be distinct.
'
    ' Interpolazione lineare:
    LinInt = Y(klo) + (Y(khi) - Y(klo)) * (Xn - X(klo)) / h
'
'
'
End Function
Public Sub InterpolaL(ByVal Ich As Long, Ps() As P_Type, Pc() As P_Type, _
    ByVal Tau As Double, Optional ByRef YMed As Double, Optional ByRef YAbsMax As Double)
'
'   Interpolazione lineare a tratti.
'
'   Parametri:
'    Ps(ICh).X|Y(0 to NPs): vettore dei punti, dati, da approssimare.
'    Pc(ICh).X|Y(0 to NPc): Vettore dei punti, calcolati, della curva interpolante.
'    Tau:                   ritardo del segnale interpolato [s].
'    YMed:                  valor medio dei punti della curva approssimante.
'    YAbsMax:               valor assoluto massimo dei punti della curva approssimante.
'
'   - I valori di Ps(ICh).X() possono non essere equispaziati
'     ma devono essere in ordine crescente.
'   - I valori ritornati in Pc(ICh).X() sono equispaziati.
'   - E': Ps(ICh).X(0) = Pc(ICh).X(0); Ps(ICh).X(NPs) = Pc(ICh).X(NPc)
'
'   Versione modificata per SigGen.
'
    Dim I&, NPs&, NPc&, dT#, T#, Xi#
'
    NPs = UBound(Ps(Ich).X)
    NPc = UBound(Pc(Ich).X)
    ReDim X#(1 To NPs + 1), Y#(1 To NPs + 1)
'
    For I = 0 To NPs
        X(I + 1) = Ps(Ich).X(I) + Tau
        Y(I + 1) = Ps(Ich).Y(I)
    Next I
'
    YMed = 0#
    YAbsMax = 0#
    T = Ps(Ich).X(NPs) - Ps(Ich).X(0)
    dT = T / CDbl(NPc)
'
    For I = 0 To NPc
        Xi = CDbl(I) * dT
        Pc(Ich).X(I) = Xi
        If (Xi < X(1)) Then Xi = Xi + T
        If (X(NPs + 1) < Xi) Then Xi = Xi - T
        Pc(Ich).Y(I) = LinInt(X(), Y(), Xi)
'
        YMed = YMed + Pc(Ich).Y(I)
        If (YAbsMax < Abs(Pc(Ich).Y(I))) Then YAbsMax = Abs(Pc(Ich).Y(I))
    Next I
'
    YMed = (YMed - Pc(Ich).Y(NPc)) / CDbl(NPc)
'
'
'
End Sub
Public Sub InterpolaF(ByVal Ich As Long, Ps() As P_Type, Pc() As P_Type, _
    ByVal Tau As Double, Optional ByRef YMed As Double, Optional ByRef YAbsMax As Double)
'
'   Interpolazione con serie di Fourier.
'
'   Parametri:
'    Ps(ICh).X|Y(0 to NPs): vettore dei punti, dati, da approssimare.
'    Pc(ICh).X|Y(0 to NPc): vettore dei punti, calcolati, della curva interpolante.
'    Tau:                   ritardo del segnale interpolato [s].
'    YMed:                  valor medio dei punti della curva approssimante.
'    YAbsMax:               valor assoluto massimo dei punti della curva approssimante.
'
'   - I valori di Ps(ICh).X() devono essere equispaziati
'     ed in ordine crescente.
'   - I valori ritornati in Pc(ICh).X() sono equispaziati.
'   - E': Ps(ICh).X(0) = Pc(ICh).X(0); Ps(ICh).X(NPs) = Pc(ICh).X(NPc)
'
'   Versione modificata per SigGen.
'   Rev. 16/02/2007
'
    Dim I&, F&, NPs&, NPc&, NFre&, PhOff#, Ang#, dT#, Re#(), Im#()
'
    NPs = UBound(Ps(Ich).X)
    NPc = UBound(Pc(Ich).X)
    ReDim Y#(0 To NPs)
'
    For I = 0 To NPs
        Y(I) = Ps(Ich).Y(I)
    Next I
'
    ' Calcolo la serie di Fourier:
    DFT Y(), Re(), Im(), NPs, NFre
'
    ' Calcolo la curva interpolante
    ' come somma di sinusoidi:
    YMed = 0#
    YAbsMax = 0#
    dT = (Ps(Ich).X(NPs) - Ps(Ich).X(0)) / CDbl(NPc)
    PhOff = PI2 * Tau / (Ps(Ich).X(NPs) - Ps(Ich).X(0)) ' [rad].
'
    For I = 0 To NPc
        Pc(Ich).X(I) = CDbl(I) * dT
        Pc(Ich).Y(I) = 0#
        Ang = (PI2 * CDbl(I) / CDbl(NPc)) - PhOff       ' [rad].
        For F = 0 To NFre
            Pc(Ich).Y(I) = Pc(Ich).Y(I) + Re(F) * Cos(CDbl(F) * Ang) _
                                        + Im(F) * Sin(CDbl(F) * Ang)
        Next F
'
        YMed = YMed + Pc(Ich).Y(I)
        If (YAbsMax < Abs(Pc(Ich).Y(I))) Then YAbsMax = Abs(Pc(Ich).Y(I))
    Next I
'
    YMed = (YMed - Pc(Ich).Y(NPc)) / CDbl(NPc)
'
'
'
End Sub
Public Sub InterpolaC(ByVal Ich As Long, Ps() As P_Type, Pc() As P_Type, _
    ByVal Tau As Double, Optional ByRef YMed As Double, Optional ByRef YAbsMax As Double)

'
'   Interpolazione con splines cubiche.
'
'   Parametri:
'    Ps(ICh).X|Y(0 to NPs): vettore dei punti, dati, da approssimare.
'    Pc(ICh).X|Y(0 to NPc): vettore dei punti, calcolati, della curva interpolante.
'    Tau:                   ritardo del segnale interpolato [s].
'    YMed:                  valor medio dei punti della curva approssimante.
'    YAbsMax:               valor assoluto massimo dei punti della curva approssimante.
'
'   - I valori di Ps(ICh).X() possono non essere equispaziati
'     ma devono essere in ordine crescente.
'   - I valori ritornati in Pc(ICh).X() sono equispaziati.
'   - E': Ps(ICh).X(0) = Pc(ICh).X(0); Ps(ICh).X(NPs) = Pc(ICh).X(NPc)
'
'   Versione modificata per SigGen.
'
'
    Dim I&, NPs&, NPc&, dT#, T#, Xi#
'
    NPs = UBound(Ps(Ich).X)
    NPc = UBound(Pc(Ich).X)
    ReDim X#(1 To NPs + 1), Y#(1 To NPs + 1), Y2#(1 To NPs + 1), IntV#(0 To NPc)
'
    For I = 0 To NNodi(Ich)
        X(I + 1) = Ps(Ich).X(I) + Tau
        Y(I + 1) = Ps(Ich).Y(I)
    Next I
'
    ' Da chiamare sempre, inizialmente, per preparare
    ' il vettore Y2() delle derivate seconde:
    Spline X(), Y(), 1E+38, 1E+38, Y2()
'
    YMed = 0#
    YAbsMax = 0#
    T = Ps(Ich).X(NPs) - Ps(Ich).X(0)
    dT = T / CDbl(NPc)
    For I = 0 To NPc
        Xi = CDbl(I) * dT
        Pc(Ich).X(I) = Xi
        If (Xi < X(1)) Then Xi = Xi + T
        If (X(NPs + 1) < Xi) Then Xi = Xi - T
        Pc(Ich).Y(I) = SplInt(X(), Y(), Y2(), Xi)
'
        YMed = YMed + Pc(Ich).Y(I)
        If (YAbsMax < Abs(Pc(Ich).Y(I))) Then YAbsMax = Abs(Pc(Ich).Y(I))
    Next I
'
    YMed = (YMed - Pc(Ich).Y(NPc)) / CDbl(NPc)
'
'
'
End Sub
Private Sub Spline(X() As Double, Y() As Double, _
    ByVal yp1 As Double, ByVal ypn As Double, Y2() As Double)
'
'   Given arrays X(1:n) and Y(1:n) containing a tabulated function, i.e., yi = f(xi),
'   with x1 < x2 < :: : < xn , and given values yp1 and ypn for the first derivative
'   of the interpolating function at points 1 and n, respectively, this routine returns
'   an array Y2(1:n) of length n which contains the second derivatives of the interpo-
'   lating function at the tabulated points xi. If yp1 and/or ypn are equal to +1e30
'   or larger, the routine is signaled to set the corresponding boundary condition for
'   a natural spline, with zero second derivative on that boundary.
'
'   Codice tradotto dal FORTRAN (pg. 109) di:
'    Numerical Recipes in FORTRAN 77
'    The Art of Scientific Computing
'    Second Edition Volume 1 of
'    FORTRAN Numerical Recipes
'    di William H. Press ed altri.
'
    Dim I&, K&, N&
    Dim p#, qn#, Sig#, un#
    N = UBound(X)
    ReDim u#(1 To N)
'
    If (9.9E+29 < yp1) Then ' The lower boundary condition is set either to be "natural"
        Y2(1) = 0#
        u(1) = 0#
    Else                    ' or else to have a specified first derivative.
        Y2(1) = -0.5
        u(1) = (3# / (X(2) - X(1))) * ((Y(2) - Y(1)) / (X(2) - X(1)) - yp1)
    End If
    For I = 2 To N - 1  ' This is the decomposition loop of the tridiagonal
                        ' algorithm. y2 and u are used for temporary
                        ' storage of the decomposed factors.
        Sig = (X(I) - X(I - 1)) / (X(I + 1) - X(I - 1))
        p = Sig * Y2(I - 1) + 2#
        Y2(I) = (Sig - 1#) / p
        u(I) = (6# * ((Y(I + 1) - Y(I)) / (X(I + 1) - X(I)) - (Y(I) - Y(I - 1)) _
             / (X(I) - X(I - 1))) / (X(I + 1) - X(I - 1)) - Sig * u(I - 1)) / p
    Next I
'
    If (9.9E+29 < ypn) Then ' The upper boundary condition is set either to be "natural"
        qn = 0#
        un = 0#
    Else                    ' or else to have a specified first derivative.
        qn = 0.5
        un = (3# / (X(N) - X(N - 1))) * (ypn - (Y(N) - Y(N - 1)) / (X(N) - X(N - 1)))
    End If
'
    Y2(N) = (un - qn * u(N - 1)) / (qn * Y2(N - 1) + 1#)
    For K = N - 1 To 1 Step -1  ' This is the backsubstitution loop of the tridiago-
                                ' nal algorithm.
        Y2(K) = Y2(K) * Y2(K + 1) + u(K)
    Next K
'
'
'
End Sub
Private Function SplInt(X() As Double, Y() As Double, Y2() As Double, _
    ByVal Xn As Double) As Double
'
'   Given the arrays X(1:N) and Y(1:N) of length N, which tabulate a function (with the
'   xi 's in order), and given the array Y2(1:N), which is the output from Spline above,
'   and given a value of Xn, this routine returns a cubic-spline interpolated value.
'
'   Codice tradotto dal FORTRAN (pg. 110) di:
'    Numerical Recipes in FORTRAN 77
'    The Art of Scientific Computing
'    Second Edition Volume 1 of
'    FORTRAN Numerical Recipes
'    di William H. Press ed altri.
'
    Dim K&, khi&, klo&
    Dim A#, B#, h#
'
    ' We will find the right place in the table by means of bisection.
    ' This is optimal if sequential calls to this routine are at random
    ' values of x. If sequential calls are in order, and closely
    ' spaced, one would do better to store previous values of
    ' klo and khi and test if they remain appropriate on the next call.
    klo = 1
    khi = UBound(X)
'
    Do While (1 < khi - klo)
        K = (khi + klo) / 2
        If (Xn < X(K)) Then
            khi = K
        Else
            klo = K
        End If
    Loop
    ' klo and khi now bracket the input value of xn.
'
    h = X(khi) - X(klo)
    'if (h = 0#) Then ...  routine di gestione errore.  ' bad xi input in Splint
                                                        ' The xi 's must be distinct.
'
    A = (X(khi) - Xn) / h   ' Cubic spline polynomial is now evaluated.
    B = (Xn - X(klo)) / h
    SplInt = A * Y(klo) + B * Y(khi) _
           + ((A * A * A - A) * Y2(klo) + (B * B * B - B) * Y2(khi)) * (h * h) / 6#
'
'
'
End Function
Public Function Sequenza1_2_5(ByVal ValI As Double, _
    Optional ByVal bMantissaInSeq As Boolean = False, _
    Optional ByVal ValMax As Double = 1E+300) As Double
'
'   Ritorna il prossimo valore nella sequenza ... -> 1 -> 2 -> 5 -> 10 -> ...
'   Se bMantissaInSeq = True e ValI e' gia' uno dei numeri della sequenza
'   ritorna lo stesso ValI; se ValI <= 0 ritorna 1.  Il valore massimo
'   della sequenza e' limitato al valore ValMax:
'
    Dim ValE$, rrM#, rrE#, Seq1_2_5#
'
    ValE$ = Format$(ValI, "0.000000E+000")
    rrM = CDbl(Left$(ValE$, 8))
    rrE = CDbl("1" & Right$(ValE$, 5))
'
    Seq1_2_5 = 1
'
    If bMantissaInSeq And ((rrM = 1) Or (rrM = 2) Or (rrM = 5)) Then
       Seq1_2_5 = ValI
'
    ElseIf (1 <= rrM) And (rrM < 2) Then
        Seq1_2_5 = 2 * rrE
    ElseIf (2 <= rrM) And (rrM < 5) Then
        Seq1_2_5 = 5 * rrE
    ElseIf (5 <= rrM) And (rrM < 10) Then
        Seq1_2_5 = 10 * rrE
    End If
'
    If (Seq1_2_5 <= ValMax) Then
        Sequenza1_2_5 = Seq1_2_5
    Else
        Sequenza1_2_5 = ValMax
    End If
'
'
'
End Function
Public Function Sequenza5_2_1(ByVal ValI As Double, _
    Optional ByVal bMantissaInSeq As Boolean = False, _
    Optional ByVal ValMin As Double = 0#) As Double
'
'   Ritorna il prossimo valore nella sequenza ... -> 10 -> 5 -> 2 -> 1 -> ...
'   Se bMantissaInSeq = True e ValI e' gia' uno dei numeri della sequenza
'   ritorna lo stesso ValI; se ValI <= ValMin ritorna ValMin:
'
    Dim ValE$, rrM#, rrE#, Seq5_2_1
'
    ValE$ = Format$(ValI, "0.000000E+000")
    rrM = CDbl(Left$(ValE$, 8))
    rrE = CDbl("1" & Right$(ValE$, 5))
'
    Seq5_2_1 = 0
'
    If bMantissaInSeq And ((rrM = 1) Or (rrM = 2) Or (rrM = 5)) Then
       Seq5_2_1 = ValI
'
    ElseIf (1 < rrM) And (rrM <= 2) Then
        Seq5_2_1 = 1 * rrE
    ElseIf (2 < rrM) And (rrM <= 5) Then
        Seq5_2_1 = 2 * rrE
    ElseIf (5 < rrM) And (rrM <= 10) Then
        Seq5_2_1 = 5 * rrE
    ElseIf (rrM = 1) Then
        Seq5_2_1 = 0.5 * rrE
    End If
'
    If (ValMin <= Seq5_2_1) Then
        Sequenza5_2_1 = Seq5_2_1
    Else
        Sequenza5_2_1 = ValMin
    End If
'
'
'
End Function
Public Function SequenzaMeno10(ByVal ValI As Double, _
    Optional ByVal bValoreInSeq As Boolean = False, _
    Optional ByVal ValMin As Double = -1E+300) As Double
'
'   Ritorna il prossimo valore nella sequenza ... +20 -> +10 -> 0 -> -10 -> ...
'   Se ValoreInSeq = True e ValI e' gia' un multiplo intero di 10 ritorna
'   lo stesso ValI.  Il valore minimo della sequenza e' limitato al valore ValMin:
'
    Dim bMultiplo10 As Boolean, SeqMeno10#
'
    bMultiplo10 = ((ValI / 10#) = Int(ValI / 10#))
'
    If bValoreInSeq And bMultiplo10 Then
       SeqMeno10 = ValI
'
    ElseIf bMultiplo10 Then
        SeqMeno10 = ValI - 10#
    Else
        SeqMeno10 = Int(ValI / 10#) * 10#
    End If
'
    If (ValMin <= SeqMeno10) Then
        SequenzaMeno10 = SeqMeno10
    Else
        SequenzaMeno10 = ValMin
    End If
'
'
'
End Function
Public Function SequenzaPiu10(ByVal ValI As Double, _
    Optional ByVal bValoreInSeq As Boolean = False, _
    Optional ByVal ValMax As Double = 1E+300) As Double
'
'   Ritorna il prossimo valore nella sequenza ... -> -10 -> 0 -> +10 -> +20 -> ...
'   Se ValoreInSeq = True e ValI e' gia' un multiplo intero di 10 ritorna
'   lo stesso ValI.  Il valore massimo della sequenza e' limitato al valore ValMax:
'
    Dim bMultiplo10 As Boolean, SeqPiu10#
'
    bMultiplo10 = ((ValI / 10#) = Int(ValI / 10#))
'
    If bValoreInSeq And bMultiplo10 Then
       SeqPiu10 = ValI
'
    ElseIf bMultiplo10 Then
        SeqPiu10 = ValI + 10#
    Else
        SeqPiu10 = Ceil(ValI / 10#) * 10#
    End If
'
    If (SeqPiu10 <= ValMax) Then
        SequenzaPiu10 = SeqPiu10
    Else
        SequenzaPiu10 = ValMax
    End If
'
'
'
End Function
Private Function LinTrasf(ByVal X As Double, _
    ByVal X1 As Double, ByVal Y1 As Double, _
    ByVal X2 As Double, ByVal Y2 As Double) As Double
'
'   Trasformazione lineare:
'    Y  = A * X  + B
'   con:
'    Y1 = A * X1 + B
'    Y2 = A * X2 + B
'
'   La funzione ritorna il valore Y:
'
    LinTrasf = ((Y2 - Y1) * X + (X2 * Y1 - X1 * Y2)) / (X2 - X1)
'
'
'
End Function
Public Sub SalvaPosizioneFormINI(ByVal FileINI$, ByVal frmF As Form, _
    Optional ByVal bDimensioni As Boolean = False)
'
'   Salva, sul file FileINI$ la posizione finale del Form frmF.
'   Da usare nell' evento frmF_Unload.
'   Se bDimensioni = True salva anche le dimensioni:
'
    Dim frmName$
'
    frmName$ = frmF.Name
'
    If (frmF.WindowState <> vbMinimized) Then
        SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Left", frmF.Left
        SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Top", frmF.Top
'
        If bDimensioni Then
            SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Width", frmF.Width
            SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Sub LeggiPosizioneFormINI(ByVal FileINI$, ByVal frmF As Form, _
    ByRef frmF_Left As Long, ByRef frmF_Top As Long, _
    Optional ByRef frmF_Width As Long, Optional ByRef frmF_Height As Long)
'
'   Legge la posizione iniziale [e le dimensioni] del Form frmF memorizzate
'   sul file FileINI$.
'   Da usare nell' evento frmF_Load:
'
    If FileExists(FileINI$) Then
        frmF_Left = GetIniString(FileINI$, "Posizione Forms:", _
                                 frmF.Name & "_Left", RandU(5, 4500))
        frmF_Top = GetIniString(FileINI$, "Posizione Forms:", _
                                 frmF.Name & "_Top", RandU(5, 4500))
'
        frmF_Width = GetIniString(FileINI$, "Posizione Forms:", _
                                  frmF.Name & "_Width", frmF.Width)
        frmF_Height = GetIniString(FileINI$, "Posizione Forms:", _
                                   frmF.Name & "_Height", frmF.Height)
    Else
        frmF_Left = RandU(5, 4500)
        frmF_Top = RandU(5, 4500)
'
        frmF_Width = frmF.Width
        frmF_Height = frmF.Height
    End If
'
    If ((Screen.Width - 4) < frmF_Width) Then frmF_Width = Screen.Width - 4
    If ((Screen.Height - 4) < frmF_Height) Then frmF_Height = Screen.Height - 4
'
'
'
End Sub
Public Function Quadro(ByVal picFoglio As PictureBox, _
    ByVal X0 As Double, ByVal Xn As Double, _
    ByVal Y0 As Double, ByVal Yn As Double, _
    Optional ByVal FormatVX$ = "#0.0##", _
    Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal Npx As Long = 1, _
    Optional ByRef PxN_X As Single, Optional ByRef PxN_Y As Single, _
    Optional ByVal Titolo$ = "", Optional ByVal bCsTitolo As Boolean = False, _
    Optional ByVal UnitaX$ = "", _
    Optional ByVal UnitaY$ = "", _
    Optional ByVal AutoRed As Boolean = False, _
    Optional ByRef SxMin As Single, Optional ByRef SxMax As Single, _
    Optional ByRef SyMin As Single, Optional ByRef SyMax As Single, _
    Optional ByVal ColRif As Long = vbGreen, _
    Optional ByVal ColFgl As Long = vbBlack, _
    Optional ByVal bGriglia As Boolean = True, _
    Optional ByRef tEsec As Single) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'
'    Parametri in ingresso:
'     picFoglio: PictureBox da scalare.
'     X0:        valore minimo di ascissa da rappresentare.
'     Xn:        valore massimo di ascissa da rappresentare.
'                Deve essere X0 <= Xn.
'     Y0:        valore minimo di ordinata da rappresentare.
'     Yn:        valore massimo di ordinata da rappresentare.
'                Deve essere Y0 <= Yn.
'     FormatVX$: stringa di formato dei valori sull' asse X.
'     FormatVY$: stringa di formato dei valori sull' asse Y.
'                Se la stringa di formato e' " ", i valori non vengono scritti.
'     Npx:       N di Pixels di cui si vuole conoscere
'                larghezza ed altezza in [vbUser].
'     Titolo$:   titolo del grafico.
'     bCsTitolo  se True cancella lo sfondo del titolo.
'     UnitaX$:   unita' (o titolo) dell' asse X.
'     UnitaY$:   unita' (o titolo) dell' asse Y.
'     AutoRed:   stato di picFoglio.AutoRedraw dopo il disegno del quadro.
'     ColRif:    colore degli assi, dei valori e delle griglie di riferimento.
'     ColFgl:    colore di sfondo di picFoglio.
'     bGriglia:  se True viene disegnata la griglia di riferimento;
'                se False viene fatta solo la scalatura di picFoglio.
'
'    Parametri in uscita:
'     SxMin:     valore minimo di ascissa rappresentata.
'     SxMax:     valore massimo di ascissa rappresentata.
'     SyMin:     valore minimo di ordinata rappresentata.
'     SyMax:     valore massimo di ordinata rappresentata.
'     PxN_X:     larghezza in [vbUser] ed
'     PxN_Y:     altezza in [vbUser] di Npx Pixels.
'     tEsec:     tempo impiegato a disegnare il quadro [s].
'
'   Rev. 26/08/2006.
'   Rev. 21/10/2006.
'   Rev. 03/04/2007.
'
    Dim I&, Xi#, D_X#, rrx#, YI#, D_Y#, rry#
    Dim Txt$, TW!, TH!, TxtSx!, TxtDx!, TxtDxU!, TxtAt!, TxtBs!
    Dim QxMin!, QxMax!, QyMin!, QyMax!
'
    tEsec = Timer
    On Error GoTo Quadro_ERR
'
    ' Verifico la correttezza delle scale:
    If (Xn < X0) Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If (Yn < Y0) Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
'---------------------------------------------------------------------------------------
'   Calcolo il passo di grigliatura degli assi.
'
    Dim DYMin!
    'Const ScRis& = 3                ' La risoluzione delle scale e' 10 ^ -ScRis (default).
    Const ScRis& = 9                ' La risoluzione delle scale e' 10 ^ -ScRis (per AudioCardDSP).
    Const ScMin! = 10 ^ (1 - ScRis) ' Ampiezza min. delle scale X e Y.
    Const Log10! = 2.30258509299405 ' Log(10#)
'
    ' Imposto una scala minima
    ' per l' asse X:
    If ((Xn - X0) < ScMin) Then
        X0 = X0 - ScMin / 2!
        Xn = Xn + ScMin / 2!
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = Xn - X0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If (10! < (D_X / rrx)) Then rrx = rrx * 2!
    X0 = rrx * Int(Round(X0 / rrx, ScRis))
    Xn = rrx * Ceil(Round(Xn / rrx, ScRis))
    D_X = Xn - X0
    SxMin = X0
    SxMax = Xn
'
    ' Imposto una scala minima
    ' per l' asse Y:
    If (FormatVY$ <> " ") Then
        If (Format$(Y0, FormatVY$) = Format$(Yn, FormatVY$)) Then
            DYMin = 0.0001
            Do While Format$(Y0 - DYMin, FormatVY$) = Format$(Yn + DYMin, FormatVY$)
                DYMin = 2! * DYMin
            Loop
'
            Y0 = Y0 - 10! * DYMin
            Yn = Yn + 10! * DYMin
        End If
    Else
        If ((Xn - X0) < ScMin) Then
            Y0 = Y0 - ScMin / 2!
            Yn = Yn + ScMin / 2!
        End If
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = Yn - Y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If (10! < (D_Y / rry)) Then rry = rry * 2!
    Y0 = rry * Int(Round(Y0 / rry, ScRis))
    Yn = rry * Ceil(Round(Yn / rry, ScRis))
    D_Y = Yn - Y0
    SyMin = Y0
    SyMax = Yn
'
'---------------------------------------------------------------------------------------
'   Calcolo larghezza ed altezza dei bordi.
'
    Dim Bl!, Br!, Bb!, Bt!, BDen!
    Dim TxWs!, TxWd!, TxHt!, TxHb!
'
    ' Imposto i dati di Font dei valori
    ' degli assi:
    picFoglio.FontName = "MS Sans Serif"
    picFoglio.FontSize = 8
    picFoglio.FontBold = False
'
    ' Annullo le scale precedenti:
    picFoglio.ScaleMode = vbPixels
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    If (FormatVY$ <> " ") Then
        TxWs = picFoglio.TextWidth(Format$(Y0, FormatVY$) & "W")
        If (TxWs < picFoglio.TextWidth(Format$(Yn, FormatVY$) & "W")) Then
            TxWs = picFoglio.TextWidth(Format$(Yn, FormatVY$) & "W")
        End If
    Else
        TxWs = picFoglio.TextWidth("WWW")
    End If
'
    ' Il bordo a destra deve essere sufficiente
    ' a contenere il valore Xn e l' etichetta UnitaX$:
    If (FormatVX$ <> " ") Then
        TxWd = (picFoglio.TextWidth(Format$(Xn, FormatVX$)) / 2!) _
             + picFoglio.TextWidth(UnitaX$ & "W")
    Else
        TxWd = picFoglio.TextWidth(UnitaX$ & "W")
    End If
'
    ' I bordi a sinistra ed a destra sono:
    BDen = D_X / (picFoglio.ScaleWidth - TxWs - TxWd)
    Bl = TxWs * BDen
    Br = TxWd * BDen
'
    ' Il bordo sotto e' 3 volte l' altezza dei valori:
    TxHb = 3! * Abs(picFoglio.TextHeight("H"))
'
    ' Il bordo sopra e' 2 volte l' altezza dei valori
    ' piu' l' altezza del titolo:
    picFoglio.FontSize = 12
    TxHt = TxHb + Abs(picFoglio.TextHeight(Titolo$))
'
    ' I bordi sopra e sotto sono:
    BDen = D_Y / (Abs(picFoglio.ScaleHeight) + TxHb + TxHt)
    Bb = TxHb * BDen
    Bt = TxHt * BDen
'
'---------------------------------------------------------------------------------------
'   Imposto la scala e calcolo i valori comuni.
'
    ' Imposto i bordi orizzontali
    ' e verticali:
    QxMin = X0 - Bl
    QxMax = X0 + D_X + Br
    QyMin = Y0 - Bb
    QyMax = Y0 + D_Y + Bt
'
    ' Imposto la scala di picFoglio:
    picFoglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
'
    ' Calcolo larghezza ed altezza di Npx pixels:
    PxN_X = Abs(picFoglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(picFoglio.ScaleY(Npx, vbPixels, vbUser))
'
    ' Verifico se e' richiesto il
    ' disegno della griglia:
    If (Not bGriglia) Then GoTo Fine
'
'---------------------------------------------------------------------------------------
'   Disegno assi, griglie e scrivo i valori di scala.
'
    Dim Po4_X!, Po4_Y!, EstAx!, EstAy!
'
    ' La griglia deve essere permanente:
    picFoglio.AutoRedraw = True
'
    picFoglio.Picture = LoadPicture()
    picFoglio.BackColor = ColFgl
'
    ' Calcolo larghezza ed altezza di 4 points:
    Po4_X = picFoglio.ScaleX(4, vbPoints, vbUser)   ' Uso i [Points] perche' voglio dimensioni
    Po4_Y = picFoglio.ScaleY(4, vbPoints, vbUser)   ' proporzionali a quelle dei caratteri.
'
    ' Estremita' degli assi X e Y:
    EstAx = (Xn + QxMax) / 2!
    EstAy = (Yn + QyMax) / 2!
'
    picFoglio.FontSize = 8
    picFoglio.DrawWidth = 1
    picFoglio.DrawMode = vbCopyPen
    picFoglio.ForeColor = ColRif
'
    ' Traccio la griglia verticale:
    picFoglio.DrawStyle = vbDash
    For Xi = X0 To Xn + 0.1 * rrx Step rrx
        picFoglio.Line (Xi, Y0)-(Xi, Yn), ColRif
    Next Xi
'
    ' Scrivo i valori dell' asse X:
    picFoglio.CurrentY = Y0 + Po4_Y / 2!
    If (FormatVX$ <> " ") Then
        ' Scrivo il valor minimo:
        Txt$ = Format$(X0, FormatVX$)
        TW = picFoglio.TextWidth(Txt$)
        TxtDx = X0 + TW / 2!
        picFoglio.CurrentX = X0 - TW / 2!
        picFoglio.Print Txt$;
'
        ' Scrivo il valor massimo:
        Txt$ = Format$(Xn, FormatVX$)
        TW = picFoglio.TextWidth(Txt$)
        TxtSx = Xn - TW / 2!
        picFoglio.CurrentX = TxtSx
        picFoglio.Print Txt$;
        TxtDxU = picFoglio.CurrentX
'
        For Xi = X0 + rrx To Xn - rrx + 0.1 * rrx Step rrx
            Txt$ = Format$(Xi, FormatVX$)
            ' Verifico che il formato scelto non
            ' induca ad errori di rappresentazione
            ' e che le etichette non si sovrappongano:
            TW = picFoglio.TextWidth(Txt$) / 2!
            If (Abs(Xi - CDbl(Txt$)) < (rrx / 10)) _
            And (TxtDx < (Xi - TW)) And ((Xi + TW) < TxtSx) Then
                TxtDx = Xi + TW
                picFoglio.CurrentX = Xi - TW
                picFoglio.Print Txt$;
            End If
        Next Xi
    End If
'
    ' Scrivo l' etichetta dell' asse X:
    If (0 < Len(UnitaX$)) Then
        ' Etichetta tutta a destra:
        'picFoglio.CurrentX = QxMax - picFoglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        picFoglio.CurrentX = (TxtDxU + QxMax - picFoglio.TextWidth(UnitaX$)) / 2!
        picFoglio.Print UnitaX$;
    End If
'
    ' Traccio l' asse Y:
    If (X0 <= 0!) And (0! <= Xn) Then
        picFoglio.DrawStyle = vbSolid
        picFoglio.Line (0!, Y0)-(0!, EstAy), ColRif
        picFoglio.Line (0!, EstAy)-(-Po4_X / 2!, Po4_Y + EstAy), ColRif
        picFoglio.Line (0!, EstAy)-(Po4_X / 2!, Po4_Y + EstAy), ColRif
    End If
'
    ' Traccio la griglia orizzontale:
    picFoglio.DrawStyle = vbDash
    For YI = Y0 To Yn + 0.1 * rry Step rry
        picFoglio.Line (X0, YI)-(Xn, YI), ColRif
    Next YI
'
    ' Scrivo i valori dell' asse Y:
    If (FormatVY$ <> " ") Then
        For YI = Y0 To Yn + 0.1 * rry Step rry
            picFoglio.Line (X0, YI)-(Xn, YI), ColRif
                Txt$ = Format$(YI, FormatVY$)
                ' Verifico che il formato scelto non
                ' induca ad errori di rappresentazione:
                If (Abs(YI - CSng(Txt$)) < (rry / 10)) Then
                    picFoglio.CurrentX = QxMin
                    picFoglio.CurrentY = YI - picFoglio.TextHeight(Txt$) / 2!
                    picFoglio.Print Txt$;
                End If
        Next YI
    End If
'
    ' Scrivo l' etichetta dell' asse Y:
    If (0 < Len(UnitaY$)) Then
        picFoglio.CurrentX = QxMin
        picFoglio.CurrentY = QyMax
        picFoglio.Print UnitaY$;
    End If
'
    ' Traccio l' asse X:
    If (Y0 <= 0!) And (0! <= Yn) Then
        picFoglio.DrawStyle = vbSolid
        picFoglio.Line (X0, 0!)-(EstAx, 0!), ColRif
        picFoglio.Line (EstAx, 0!)-(EstAx - Po4_X, -Po4_Y / 2!), ColRif
        picFoglio.Line (EstAx, 0!)-(EstAx - Po4_X, Po4_Y / 2!), ColRif
    End If
'
'---------------------------------------------------------------------------------------
'   Scrivo il titolo del grafico:
'
    Dim TitL!, TitT!, TitW!, TitH!, TitoloR$
'
    If (0 < Len(Titolo$)) Then
        picFoglio.FontSize = 12
        picFoglio.FontBold = True
        picFoglio.ForeColor = vbRed
'
        TitoloR$ = Titolo$
        TitW = picFoglio.TextWidth(TitoloR$)
        TitH = picFoglio.TextHeight(TitoloR$)
'
        ' Verifico che il titolo stia tutto
        ' nella larghezza del grafico ...:
        If (TitW <= (Xn - X0)) Then
            TitL = (Xn + X0 - TitW) / 2!
'
        Else
            ' ... e se no lo taglio:
            TitL = X0
            Txt$ = " . . ."
            TitoloR$ = Left$(Titolo$, Int(Len(TitoloR$) _
                          * (Xn - X0 - picFoglio.TextWidth(Txt$)) / TitW))
            If (TitoloR$ <> Titolo$) Then TitoloR$ = TitoloR$ & Txt$
        End If
'
        TitT = QyMax
        If bCsTitolo Then
            ' Cancello l' area su cui andra' scritto il titolo ...:
            picFoglio.Line (TitL + TitW, TitT + TitH)-(TitL, TitT), ColFgl, BF
        Else
        ' ... oppure no:
            picFoglio.CurrentX = TitL
            picFoglio.CurrentY = TitT
        End If
'
        picFoglio.Print TitoloR$
    End If
'
Fine:
    picFoglio.DrawStyle = vbSolid
    picFoglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err.Number = 0)
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Errore " & Str$(Err.Number) & vbNewLine & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modUtilita/Quadro"
    End If
    tEsec = Timer - tEsec
'
'
'
End Function
Public Function SaveIniString(ByVal FileINI$, ByVal Section$, ByVal Key$, _
    ByVal StringToAdd$) As Boolean
'
'
    Dim lRet As Long
'
    On Error GoTo SaveIniString_ERR
'
    lRet = WritePrivateProfileString(Section$, Key$, StringToAdd$, FileINI$)
    If (lRet = 0) Then Err.Raise 1001
'
'
SaveIniString_ERR:
    SaveIniString = (Err.Number = 0)
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Il programma ha trovato una condizione inattesa." & vbNewLine
        M$ = M$ & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " SaveIniString"
    End If
'
'
'
End Function
Public Function GetIniString(ByVal FileINI$, ByVal Section$, ByVal Key$, _
    Optional ByVal DefaultString$) As String
'
'
    Dim BUF$, e&
    Const LBF& = 255
'
    On Error GoTo GetIniString_ERR
'
    BUF$ = Space$(LBF)
'
    e = GetPrivateProfileString(Section$, Key$, DefaultString$, BUF$, LBF, FileINI$)
    GetIniString = Left$(BUF$, e)
'
'
GetIniString_ERR:
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Sezione [" & Section$ & "] nel File " & FileINI$ & vbNewLine
        M$ = M$ & "non esistente o di formato non valido." & vbNewLine
        M$ = M$ & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " GetIniString"
'
        GetIniString = ""
    End If
'
'
'
End Function
Public Function ValC2D(ByVal sNum$) As String
'
'   Sostituisce, nella stringa numerica sNum$,
'   la "," con il ".".  Rende cosi' possibile
'   usare la funzione Val su testi che usino la
'   "," come separatore decimale.
'
    ValC2D = Replace(sNum$, ",", ".")
'
'
'
End Function
Public Sub AggiornaFinestrelle(ParamArray Finestrelle() As Variant)
'
'   Aggiorna i valori delle finestrelle di informazione
'   assegnando alle Labels i corrispondenti valori.
'   Il vettore Finestrelle() deve essere organizzato come:
'    Label1, Val1, ..., LabelN, ValN
'
    Dim J&, J1&, J2&
'
    J1 = LBound(Finestrelle)
    J2 = UBound(Finestrelle) - 1
'
    For J = J1 To J2 Step 2
        Finestrelle(J).Caption = Finestrelle(J + 1)
        Finestrelle(J).BackColor = IIf(Len(Finestrelle(J + 1)) = 0, vbButtonFace, ColEvi)
    Next J
'
'
'
End Sub
Public Function LinTodB(ByVal X#, Optional ByVal Base# = 20) As Double
'
'   Calcola i [dB] corrispondenti al valore lineare X.
'   LinTodB(1) = 0 dB;  LinTodB(0.1) = -20 dB.
'
    If (0# < X) Then
        LinTodB = Base * Log(X) / Log10
    Else
        LinTodB = -9999#
    End If
'
'
'
End Function
Public Function LinToLog(ByVal X As Double, Optional ByVal Base As Double = 10#) As Double
'
'   Trasforma una posizione da Lineare a Logaritmica.
'
    If (0# < X) Then
        LinToLog = Log(X) / Log(Base)
    Else
        LinToLog = -9999#
    End If
'
'
'
End Function
Public Function dBToLin(ByVal Y As Double) As Double
'
'   Trasforma, sull' asse Y, una posizione da Logaritmica a Lineare.
'   dBToLin(0 dB) = 1,  dBToLin(-20 dB) = 0.1
'
    dBToLin = 10# ^ (Y / 20#)
'
'
'
End Function
Private Function LogToLin(ByVal X As Double, Optional ByVal Base As Double = 10#) As Double
'
'   Trasforma una posizione da Logaritmica a Lineare.
'
    LogToLin = Base ^ X
'
'
'
End Function
Public Function MIN0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vD(J) < vDMin Then vDMin = vD(J)
    Next J
'
    MIN0 = CLng(vDMin)
'
'
'
End Function
Public Function DMIN1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vD(J) < vDMin Then vDMin = vD(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Sub CloseButtonDisable(ByVal frmF As Form)
'
'
    Dim lRet As Long
'
    lRet = RemoveMenu(GetSystemMenu(frmF.hWnd, 0), SC_CLOSE, MF_REMOVE)
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$, _
    Optional ByVal MAXFIL As Long = 5)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   MAXFIL e' il numero massimo di files recenti da ricordare:
'   puo' essere diverso a seconda dell' applicazione che usa
'   questa routine (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim A$, NuovoFile As Boolean
'
    If (FileRec$ = "") Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        A$ = mnuRecenti(F).Caption
        If (UCase$(Right$(A$, Len(A$) - 3)) = UCase$(FileRec$)) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If (FILN < F) Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (0 < FILN)
'
    For I = F To 2 Step -1
        A$ = mnuRecenti(I - 1).Caption
        A$ = "&" & Trim$(Str$(I)) & " " & Right$(A$, Len(A$) - 3)
        mnuRecenti(I).Caption = A$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecentiINI(ByVal FileINI$, ByVal mnuRecenti As Object, ByVal Sezione$, _
    Optional ByVal MAXFIL As Long = 5, Optional ByVal VerificaFE As Boolean = True)
'
'   Legge i files recenti dal file FileINI$ e li aggiunge al menu mnuRecenti().
'   Se VerificaFE = True verifica anche l' esistenza dei files da aggiungere:
'
    Dim I&, FileRec$
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetIniString(FileINI$, Sezione$, Str$(I), "")
        If (FileRec$ <> "") Then
            If VerificaFE Then
                If FileExists(FileRec$) Then AggiornaFilesRecenti mnuRecenti, FileRec$
            Else
                AggiornaFilesRecenti mnuRecenti, FileRec$
            End If
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecentiINI(ByVal FileINI$, ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva i files recenti, contenuti nel menu mnuRecenti(), sul file FileINI$:
'
    Dim I&, FileRec$
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveIniString FileINI$, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub
Public Function MAX0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MAX0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If vDMax < vD(J) Then vDMax = vD(J)
    Next J
'
    MAX0 = CLng(vDMax)
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If ((InStr(TextB.Text, SD$) = 0) _
    And Not ((TextB.SelStart = 0) And (Left$(TextB.Text, 1) = "-"))) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If ((Left$(TextB.Text, 1) <> "-") Or (TextB.SelText = TextB.Text)) _
    And NEG And (TextB.SelStart = 0) Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If (0 < TextB.SelStart) Then
        KA = Asc(UCase$(Chr$(KA)))
        If ((InStr(TextB.Text, "E") = 0) _
        And Not ((TextB.SelStart = 0) Or (TextB.SelText = TextB.Text))) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If (Mid$(TextB.Text, TextB.SelStart, 1) = "E") Then KeyMinus = myKeyMinus
'
        If (0 < InStr(TextB.Text, "E")) _
        And (0 <= (TextB.SelStart - InStr(TextB.Text, "E"))) Then KeyDecimal = 0
    End If
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
        Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(ByRef DS$, Optional ByRef MS$)
'
'   Trova i separatori decimale e
'   delle migliaia del sistema:
'
    DS$ = "  "
    MS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, DS$, Len(DS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
'
    DS$ = Left$(DS$, 1)
    MS$ = Left$(MS$, 1)
'
'
'
End Sub
Public Function FormatE$(ByVal vNum As Variant, Optional ByVal strF$ = "0.0#####E-00")
'
'   Ritorna il valore vNum in formato scientifico
'   ingegneristico (i.e. con esponente multiplo di 3):
'
    Dim FTemp$, MEsp&
'
    strF$ = UCase$(strF$)
    If (Left$(strF$, 1) = "+") Or (Left$(strF$, 1) = "-") Then
        strF$ = Mid$(strF$, 2)
    End If
'
    FTemp$ = Format$(vNum, strF$)
    MEsp = Val(Mid$(FTemp$, InStr(FTemp$, "E") + 1)) Mod 3
'
    If (0 < MEsp) Then
        strF$ = String(MEsp, "#") & strF$
    ElseIf (MEsp < 0) Then
        strF$ = String(3 - Abs(MEsp), "#") & strF$
    End If
'
    FormatE$ = Format$(vNum, strF$)
'
'
'
End Function
Public Function Acos(ByVal X As Double) As Double
'
'   Calcola l' ArcoCoseno di x con -1 <= x <= 1.
'   Acos e' in radianti.
'
    If (0# < X) And (X <= 1#) Then
        Acos = Atn(Sqr(1# - X * X) / X)
    ElseIf (-1# <= X) And (X < 0#) Then
        Acos = PI + Atn(Sqr(1# - X * X) / X)
    ElseIf (X = 0#) Then
        Acos = PI / 2#
    Else
        Err.Raise 5, "Acos Function", "Argomento illegale per Acos"
    End If
'
'
'
End Function
Public Function Asin(ByVal X As Double) As Double
'
'   Calcola l' ArcoSeno di x con -1 <= x <= 1.
'   Asin e' in radianti.
'
    If (Abs(X) < 1#) Then
        Asin = Atn(X / Sqr(1# - X * X))
    ElseIf (X = 1#) Then
        Asin = PI / 2#
    ElseIf (X = -1#) Then
        Asin = -PI / 2#
    Else
        Err.Raise 5, "Asin Function", "Argomento illegale per Asin"
    End If
'
'
'
End Function
Public Function Atan2(ByVal Y As Double, ByVal X As Double) As Double
'
'   Ritorna il Valore dell' ArcoTangente su 4 Quadranti.
'   E':    0 <= Atan2 < 2 * PI.
'
    Select Case X
        Case Is > 0#
        Atan2 = IIf(0# <= Y, Atn(Y / X), Atn(Y / X) + PI2)
'
        Case Is < 0#
        Atan2 = Atn(Y / X) + PI
'
        Case Is = 0#
        Atan2 = PI * Sgn(Y) / 2#
    End Select
'
'
'
End Function
Private Function RandR(ByVal Sigma As Single) As Single
'
'   Ritorna una variabile casuale reale a distribuzione di Rayleigh:
'
    RandR = Sqr(-2! * Sigma * Sigma * Log(1! - Rnd))
'
'
'
End Function
Private Function RandU(ByVal V_Min As Single, ByVal V_Max As Single) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme:
'
    RandU = V_Min + (V_Max - V_Min) * Rnd
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA As Integer, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus As Integer
    'Dim TextB As TextBox    ' Solo per TextBoxes.
    Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    If ((Left$(TextB.Text, 1) <> "-") Or (TextB.SelText = TextB.Text)) _
    And NEG And (TextB.SelStart = 0) Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
        Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Private Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If (X = Int(X)) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function
Public Function IsLoaded(ByVal frmF As Form) As Boolean
'
'   Ritorna True se il Form frmF e' gia' caricato in memoria:
'
    Dim I As Long
'
    For I = 0 To Forms.Count - 1
        If Forms(I) Is frmF Then
            IsLoaded = True
            Exit Function
        End If
    Next I
'
    IsLoaded = False
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef Pname$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'   Full$  = Nome completo del File.
'   PName$ = Path del File (con \ finale).
'   FName$ = Nome del File con Estensione.
'   Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        Pname$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            Pname$ = Pname$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        Pname$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If (Dot <> 0) Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Public Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim lRet As Long
'
    On Error Resume Next
'
    lRet = FileLen(FileN$)
    FileExists = (Err.Number = 0)
    Err.Clear
'
'
'
End Function
Public Sub Stat_F(ByVal FileN$, _
    Optional ByRef dVMin As Double, Optional ByRef dVMax As Double, _
    Optional ByRef dVMedio As Double, Optional ByRef dDevStd As Double, _
    Optional ByRef lNVal As Long, Optional ByRef dSVal As Double)
'
'   Calcola alcuni valori statistici dei
'   dati contenuti nel file FileN$:
'
    Dim FF%, dVal#, dSValQ#
'
    On Error GoTo Stat_F_ERR
'
    FF = FreeFile
    Open FileN$ For Input As #FF
'
    On Error GoTo Stat_F_ERR
'
    dVMin = 1E+300
    dVMax = -1E+300
    lNVal = 0
    dSVal = 0#
'
    Do While Not EOF(FF)
        Input #FF, dVal
        lNVal = lNVal + 1
        If (dVal < dVMin) Then dVMin = dVal
        If (dVMax < dVal) Then dVMax = dVal
        dSVal = dSVal + dVal
        dSValQ = dSValQ + dVal * dVal
    Loop
'
    dVMedio = dSVal / CDbl(lNVal)
    dDevStd = CDbl(lNVal) * dSValQ - dSVal * dSVal
    dDevStd = Sqr(dDevStd / (CDbl(lNVal) * (CDbl(lNVal - 1))))
'
'
Stat_F_ERR:
    Close #FF
    If (Err.Number <> 0) Then
        Dim M$
        M$ = Err.Number & "  " & Err.Description & vbNewLine
        If (lNVal < 2) Then M$ = M$ & "Il File dei dati contiene meno di 2 valori."
        MsgBox M$, vbCritical, " Errore in Stat_F"
    End If
'
'
'
End Sub
Public Function ContainerEnabled(ByVal ctrContainer As Control, _
    ByVal bEnabled As Boolean) As Boolean
'
'   Abilita o disabilita ctrContainer e
'   tutti i controlli al suo interno.
'   La routine e' ricorsiva.
'
    Dim Control As Control, ControlC As Control
'
    On Error Resume Next    ' Gestisce i controlli senza proprieta' .Enabled
                            ' e quelli senza proprieta' .Container.
'
    'Exit Function   ' Uscita di sicurezza, per poter usare il "Break on All Errors".
'
    ctrContainer.Enabled = bEnabled
    DoEvents
'
    For Each Control In ctrContainer.Parent.Controls
        If (Control.Container Is ctrContainer) Then
            If (TypeOf Control Is Frame) _
            Or (TypeOf Control Is PictureBox) Then
                ContainerEnabled Control, bEnabled
            Else
                If (Err.Number = 0) Then Control.Enabled = bEnabled
                Err.Clear
            End If
        End If
    Next Control
'
    ContainerEnabled = (Err.Number = 0)
'
'
'
End Function
Public Sub Stat_V(dVal() As Double, _
    Optional ByRef dVMin As Double, Optional ByRef dVMax As Double, _
    Optional ByRef dVMedio As Double, Optional ByRef dDevStd As Double, _
    Optional ByRef lNVal As Long, Optional ByRef dSVal As Double)
'
'   Calcola alcuni valori statistici dei
'   dati contenuti nel vettore dVal():
'
    Dim I&, dSValQ#
'
    On Error GoTo Stat_V_ERR
'
    lNVal = UBound(dVal) - LBound(dVal) + 1
    If (lNVal < 2) Then Err.Raise 5
'
    dVMin = dVal(LBound(dVal))
    dVMax = dVal(LBound(dVal))
    dSVal = dVMin
    dSValQ = dVMin * dVMin
'
    For I = LBound(dVal) + 1 To UBound(dVal)
        If (dVal(I) < dVMin) Then dVMin = dVal(I)
        If (dVMax < dVal(I)) Then dVMax = dVal(I)
        dSVal = dSVal + dVal(I)
        dSValQ = dSValQ + dVal(I) * dVal(I)
    Next I
'
    dVMedio = dSVal / CDbl(lNVal)
    dDevStd = CDbl(lNVal) * dSValQ - dSVal * dSVal
    dDevStd = Sqr(dDevStd / (CDbl(lNVal) * (CDbl(lNVal - 1))))
'
'
Stat_V_ERR:
    If (Err.Number <> 0) Then
        Dim M$
        M$ = Err.Number & "  " & Err.Description & vbNewLine
        If (lNVal < 2) Then M$ = M$ & "Il vettore dei dati contiene meno di 2 valori."
        MsgBox M$, vbCritical, " Errore in Stat_V"
    End If
'
'
'
End Sub
Public Function PinkNoise(ByVal Ich As Long, ByRef Idum As Long) As Single
'
'   Filter to make pink noise from white  (updated March 2000)
'   ---------------------------------------------------------

'   This is an approximation to a -10dB/decade filter using a weighted sum
'   of first order filters. It is accurate to within +/-0.05dB above 9.2Hz
'   (44100Hz sampling rate). Unity gain is at Nyquist, but can be adjusted
'   by scaling the numbers at the end of each line.
'
'   If 'white' consists of uniform random numbers, such as those generated
'   by the rand() function, 'pink' will have an almost gaussian level
'   distribution.
'
'   paul.kellett@ maxim.abel.co.uk
'   http://www.abel.co.uk/~maxim/
'
'   Versione modificata per SigGen ed atta alla
'   generazione di due flussi di dati:
'
    Dim K&
'
'    Static b3!(1 To 2), b4!(1 To 2), b5!(1 To 2), b6!(1 To 2)
'
'    b0(ICh) = 0.99886 * b0(ICh) + WhiteNoise(Idum) * 0.0555179
'    b1(ICh) = 0.99332 * b1(ICh) + WhiteNoise(Idum) * 0.0750759
'    b2(ICh) = 0.969 * b2(ICh) + WhiteNoise(Idum) * 0.153852
'    b3(ICh) = 0.8665 * b3(ICh) + WhiteNoise(Idum) * 0.3104856
'    b4(ICh) = 0.55 * b4(ICh) + WhiteNoise(Idum) * 0.5329522
'    b5(ICh) = -0.7616 * b5(ICh) - WhiteNoise(Idum) * 0.016898
'    PinkNoise = b0(ICh) + b1(ICh) + b2(ICh) + b3(ICh) _
'              + b4(ICh) + b5(ICh) + b6(ICh) + WhiteNoise(Idum) * 0.5362
'    b6(ICh) = WhiteNoise(Idum) * 0.115926
'
'   An 'economy' version with accuracy of +/-0.5dB is also available:
    Static b0!(1 To 2), b1!(1 To 2), b2!(1 To 2)
'
'    b0(ICh) = 0.99765 * b0(ICh) + WhiteNoise(Idum) * 0.099046
'    b1(ICh) = 0.963 * b1(ICh) + WhiteNoise(Idum) * 0.2965164
'    b2(ICh) = 0.57 * b2(ICh) + WhiteNoise(Idum) * 1.0526913
'    PinkNoise = b0(ICh) + b1(ICh) + b2(ICh) + WhiteNoise(Idum) * 0.1848
'
    ' Versione "economy" con sviluppo in linea di WhiteNoise(Idum)
    ' per velocizzare l' esecuzione della routine:
    Idum = (Idum Xor MASK)  ' XORing with MASK allows use of zero and other simple
                            ' bit patterns for idum.
'
    ' b0(ICh):
    K = Idum / IQ
    Idum = IA * (Idum - K * IQ) - IR * K    ' Compute idum=mod(IA*idum,IM) without
                                            ' overflows by Schrage 's method.
    If (Idum < 0) Then Idum = Idum + Im
    b0(Ich) = 0.99765 * b0(Ich) _
            + PN0 * Idum - 0.099046         ' Convert idum to a floating result.
'
    ' b1(ICh):
    K = Idum / IQ
    Idum = IA * (Idum - K * IQ) - IR * K
'
    If (Idum < 0) Then Idum = Idum + Im
    b1(Ich) = 0.963 * b1(Ich) _
            + PN1 * Idum - 0.2965164
'
    ' b2(ICh):
    K = Idum / IQ
    Idum = IA * (Idum - K * IQ) - IR * K
'
    If (Idum < 0) Then Idum = Idum + Im
    b2(Ich) = 0.57 * b2(Ich) _
            + PN2 * Idum - 1.0526913
'
    ' PinkNoise:
    K = Idum / IQ
    Idum = IA * (Idum - K * IQ) - IR * K
'
    If (Idum < 0) Then Idum = Idum + Im
    PinkNoise = b0(Ich) + b1(Ich) + b2(Ich) _
              + PN3 * Idum - 0.1848
'
    Idum = (Idum Xor MASK)  ' Unmask before return.
'
'
'
End Function
Public Function WhiteNoise(ByRef Idum As Long) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme
'   con -1.0 < WhiteNoise < 1.0:
'
    Dim K As Long
'
    ' Invece che calcolare WhiteNoise = 2! * Ran0(Idum) - 1!
    ' uso, per velocizzare la routine, lo sviluppo in linea
    ' di Ran0(Idum):
    Idum = (Idum Xor MASK)  ' XORing with MASK allows use of zero and other simple
                            ' bit patterns for idum.
'
    K = Idum / IQ
    Idum = IA * (Idum - K * IQ) - IR * K    ' Compute idum=mod(IA*idum,IM) without
                                            ' overflows by Schrage 's method.
    If (Idum < 0) Then Idum = Idum + Im
'
    WhiteNoise = AM2 * Idum - 1#            ' Convert idum to a floating result;
                                            ' -1.0 < WhiteNoise < +1.0.
'
    Idum = (Idum Xor MASK)  ' Unmask before return.
'
'
'
End Function
Public Sub DSHIFT(dArray() As Double, ByVal Shift As Long)
'
'   Esegue la rotazione di Shift posti a sinistra (Shift > 0)
'   od a destra (Shift < 0) degli elementi del vettore dArray().
'   E' simile alla procedura intrinseca CSHIFT del FORTRAN, ma
'   solo per Array ad una dimensione e di tipo Double.
'   Il numero di elementi nel vettore dArray() deve essere
'   maggiore di uno.
'
    Dim I0&, I1&, I2&, N&, NB1&
'
    I0 = LBound(dArray)
    I2 = UBound(dArray)
'
    N = I2 - I0 + 1
    If (N <= 1) Then Exit Sub
'
    I1 = -Shift Mod N
'
    If I1 <> 0 Then
        If (I1 < 0) Then I1 = I1 + N
        ReDim dTemp#(I0 To I2)
'
        NB1 = N - I1
'
        ' Con API (piu' veloce):
        CopyMemory dTemp(I0 + I1), dArray(I0), 8 * NB1
        CopyMemory dTemp(I0), dArray(I0 + NB1), 8 * I1
'
        ' Senza API:
'        Dim I&
'        For I = 0 To NB1 - 1
'            dTemp(I0 + I1 + I) = dArray(I0 + I)
'        Next I
'        For I = 0 To I1 - 1
'            dTemp(I0 + I) = dArray(I0 + NB1 + I)
'        Next I
'
        dArray() = dTemp()
    End If
'
'
'
End Sub
Public Sub DSHIFT_1(dArray() As Double, ByVal Shift As Long)
'
'   Esegue la rotazione di Shift posti a sinistra (Shift > 0)
'   od a destra (Shift < 0) degli elementi del vettore dArray().
'   E' simile alla procedura intrinseca CSHIFT del FORTRAN, ma
'   solo per Array ad una dimensione e di tipo Double.
'   Il numero di elementi nel vettore dArray() deve essere
'   maggiore di due.
'
'   Versione modificata per SigGen, i.e. per "shiftare" solo i
'   primi N - 1 valori; l' ultimo e' posto uguale al primo.
'
    Dim I0&, I1&, I2&, N_1&, NB1&
'
    I0 = LBound(dArray)
    I2 = UBound(dArray)
'
    N_1 = I2 - I0
    If (N_1 <= 1) Then Exit Sub
'
    I1 = -Shift Mod N_1
'
    If (I1 <> 0) Then
        If (I1 < 0) Then I1 = I1 + N_1
        ReDim dTemp#(I0 To I2)
'
        NB1 = N_1 - I1
'
        CopyMemory dTemp(I0 + I1), dArray(I0), 8 * NB1
        CopyMemory dTemp(I0), dArray(I0 + NB1), 8 * I1
'
        dArray() = dTemp()
    End If
'
    dArray(I2) = dArray(I0)
'
'
'
End Sub
Public Function MODULO(aa As Double, pp As Double) As Double
'
'   Implementa la funzione MODULO(a, p) del FORTRAN:
'
    MODULO = aa - Int(aa / pp) * pp
'
'
'
End Function
Public Function SIGN(ByVal dV As Double, ByVal DS As Double) As Double
'
'   Ritorna il valore assoluto di dV con il segno di dS.
'   Implementa la funzione SIGN del FORTRAN:
'
    If DS < 0 Then
        SIGN = -Abs(dV)
    Else
        SIGN = Abs(dV)
    End If
'
'
'
End Function
